From 42c136761d2735e692896a9e7b31789089135ec5 Mon Sep 17 00:00:00 2001
From: Peter Geoghegan <pg@bowt.ie>
Date: Wed, 25 Mar 2026 16:48:43 -0400
Subject: [PATCH v28 02/11] Add amgetbatch interface and adopt it in nbtree.

Add a new amgetbatch index AM interface that allows index access methods
to implement plain index scans and index-only scans that return index
entries in batches comprising all matching items from an index page,
rather than one match at a time.  Also switch nbtree over from
amgettuple to the new amgetbatch interface.

The new interface allows the table AM to apply knowledge of which TIDs
will be returned to the scan in the near future to perform optimizations
like I/O prefetching.  Prefetching is set to be added by an upcoming commit.

With amgetbatch, a scan-level policy determines whether each batch's
index page buffer pin is dropped eagerly by the index AM (for plain
scans with an MVCC snapshot, where the snapshot itself prevents TID
recycling problems) or retained as an interlock against concurrent TID
recycling by VACUUM.  The interlock is retained for plain non-MVCC scans
and for index-only scans, and is dropped by the table AM via the new
amunguardbatch callback when it is safe to do so. (Actually, index AMs
are usually able to drop the pin at the same time that they release the
lock.  In practice, the amunguardbatch callback is only really needed
during index-only scans, where dropping the pin interlock might need to
be delayed ever so slightly, as explained below.)

This extends the dropPin mechanism added to nbtree by commit 2ed5b87f,
and generalizes it to work with all index AMs that support the new
amgetbatch interface (LP_DEAD marking of index entries must be performed
by implementing the new amkillitemsbatch callback, which has a
documented contract describing how index AMs must reason about
concurrent TID recycling).  Scans can always safely drop index page pins
eagerly, provided the scan uses an MVCC snapshot (unlike the nbtree
dropPin optimization, which had no way of doing this safely during
index-only scans due to how amgettuple works, and only gained support
for scans of unlogged relations in recent commit 8a879119).

The old ammarkpos and amrestrpos index AM callbacks are removed.  With
amgetbatch, mark/restore of scan positions is managed by the table AM,
with help from indexbatch.c utility functions, rather than being wholly
delegated to the index AM.  The new index_scan_markpos and
index_scan_restrpos table AM callbacks must be implemented to make all
this work.  As a further condition, mark/restore is only supported by
index AMs that opt in by setting the new amcanmarkpos flag (only nbtree
sets this to true).  This amcanmarkpos flag scheme avoids the assumption
that every index AM is capable of picking up a scan from a previously
saved markBatch.

An upcoming commit that will add index prefetching will use a read
stream to read heap pages during index scans.  Read stream is careful to
limit how many things it pins, lest we run into problems due to having
too many buffers pinned.  Simply never holding on to index page buffer
pins greatly simplifies resource management for index prefetching;
there's no risk of unintended interactions between the read stream and
index AM.  The only downside is that we cannot support prefetching
during scans that use a non-MVCC snapshot, which seems quite acceptable.

In practice, heapam doesn't drop each batch's index page buffer pin at
the earliest opportunity during index-only scans.  This was deemed
necessary to avoid regressing index-only scans with a LIMIT, in
particular with nestloop anti-joins and nestloop semi-joins; eagerly
loading all the visibility information up front regressed such queries.
The new amgetbatch interface gives table AMs the authority to decide
when to drop index page pins/unguard batches, so this can be considered
a heapam implementation detail (index AMs don't need to know about it).
This scheme enables index prefetching to acquire and then drop any extra
batch index page pin within its read stream callback -- even when an
index-only scan (that must perform some heap fetches) holds open several
index batches at once in order to maintain an adequate prefetch
distance.  The read stream cannot observe any change in the backend's
buffer pin limit.

Index access methods that support plain index scans must now implement
either the amgetbatch interface or the amgettuple interface (not both).
Upcoming patches will add support for amgetbatch to the hash, GiST, and
SP-GiST index AMs.

Author: Tomas Vondra <tomas@vondra.me>
Author: Peter Geoghegan <pg@bowt.ie>
Reviewed-by: Andres Freund <andres@anarazel.de>
Reviewed-by: Thomas Munro <thomas.munro@gmail.com>
Discussion: https://postgr.es/m/cf85f46f-b02f-05b2-5248-5000b894ebab@enterprisedb.com
Discussion: https://postgr.es/m/efac3238-6f34-41ea-a393-26cc0441b506%40vondra.me
---
 src/include/access/amapi.h                    |  29 +-
 src/include/access/genam.h                    |   5 +-
 src/include/access/heapam.h                   |   7 +-
 src/include/access/indexbatch.h               | 535 ++++++++++++
 src/include/access/nbtree.h                   | 190 ++---
 src/include/access/relscan.h                  | 206 ++++-
 src/include/access/tableam.h                  | 102 ++-
 src/include/nodes/pathnodes.h                 |   6 +-
 src/backend/access/brin/brin.c                |   7 +-
 src/backend/access/gin/ginget.c               |   6 +-
 src/backend/access/gin/ginutil.c              |   7 +-
 src/backend/access/gist/gist.c                |   7 +-
 src/backend/access/hash/hash.c                |   7 +-
 src/backend/access/heap/heapam_handler.c      |   5 +-
 src/backend/access/heap/heapam_indexscan.c    | 525 +++++++++++-
 src/backend/access/index/Makefile             |   3 +-
 src/backend/access/index/amapi.c              |   5 +
 src/backend/access/index/genam.c              |   7 +
 src/backend/access/index/indexam.c            | 138 +--
 src/backend/access/index/indexbatch.c         | 798 ++++++++++++++++++
 src/backend/access/index/meson.build          |   1 +
 src/backend/access/nbtree/README              |  74 +-
 src/backend/access/nbtree/nbtpage.c           |  13 +-
 src/backend/access/nbtree/nbtreadpage.c       | 207 +++--
 src/backend/access/nbtree/nbtree.c            | 465 +++++-----
 src/backend/access/nbtree/nbtsearch.c         | 566 ++++++-------
 src/backend/access/nbtree/nbtutils.c          | 245 ------
 src/backend/access/nbtree/nbtxlog.c           |   6 +-
 src/backend/access/spgist/spgutils.c          |   7 +-
 src/backend/access/table/tableamapi.c         |   5 +-
 src/backend/commands/indexcmds.c              |   2 +-
 src/backend/executor/nodeIndexonlyscan.c      |   4 +-
 src/backend/executor/nodeIndexscan.c          |   4 +-
 src/backend/executor/nodeMergejoin.c          |   4 +-
 src/backend/optimizer/path/indxpath.c         |   6 +-
 src/backend/optimizer/util/plancat.c          |   8 +-
 src/backend/replication/logical/relation.c    |   9 +-
 src/backend/utils/adt/amutils.c               |   8 +-
 contrib/amcheck/verify_nbtree.c               |   2 +-
 contrib/bloom/blutils.c                       |   7 +-
 doc/src/sgml/indexam.sgml                     | 588 +++++++++++--
 doc/src/sgml/ref/create_table.sgml            |  13 +-
 .../modules/dummy_index_am/dummy_index_am.c   |   7 +-
 src/test/regress/expected/join.out            |  63 +-
 src/test/regress/expected/portals.out         |  57 ++
 src/test/regress/sql/join.sql                 |  38 +-
 src/test/regress/sql/portals.sql              |  34 +
 src/tools/pgindent/typedefs.list              |  15 +-
 48 files changed, 3614 insertions(+), 1439 deletions(-)
 create mode 100644 src/include/access/indexbatch.h
 create mode 100644 src/backend/access/index/indexbatch.c

diff --git a/src/include/access/amapi.h b/src/include/access/amapi.h
index 792403335..02793a115 100644
--- a/src/include/access/amapi.h
+++ b/src/include/access/amapi.h
@@ -199,6 +199,19 @@ typedef void (*amrescan_function) (IndexScanDesc scan,
 typedef bool (*amgettuple_function) (IndexScanDesc scan,
 									 ScanDirection direction);
 
+/* next batch of valid tuples */
+typedef IndexScanBatch (*amgetbatch_function) (IndexScanDesc scan,
+											   IndexScanBatch priorbatch,
+											   ScanDirection direction);
+
+/* drop TID recycling interlock held to prevent concurrent VACUUM recycling */
+typedef void (*amunguardbatch_function) (IndexScanDesc scan,
+										 IndexScanBatch batch);
+
+/* mark dead items in index page */
+typedef void (*amkillitemsbatch_function) (IndexScanDesc scan,
+										   IndexScanBatch batch);
+
 /* fetch all valid tuples */
 typedef int64 (*amgetbitmap_function) (IndexScanDesc scan,
 									   TIDBitmap *tbm);
@@ -206,11 +219,9 @@ typedef int64 (*amgetbitmap_function) (IndexScanDesc scan,
 /* end index scan */
 typedef void (*amendscan_function) (IndexScanDesc scan);
 
-/* mark current scan position */
-typedef void (*ammarkpos_function) (IndexScanDesc scan);
-
-/* restore marked scan position */
-typedef void (*amrestrpos_function) (IndexScanDesc scan);
+/* invalidate index AM state that independently tracks scan's position */
+typedef void (*amposreset_function) (IndexScanDesc scan,
+									 IndexScanBatch batch);
 
 /*
  * Callback function signatures - for parallel index scans.
@@ -255,6 +266,8 @@ typedef struct IndexAmRoutine
 	bool		amconsistentordering;
 	/* does AM support backward scanning? */
 	bool		amcanbackward;
+	/* does AM support mark/restore of a scan position? */
+	bool		amcanmarkpos;
 	/* does AM support UNIQUE indexes? */
 	bool		amcanunique;
 	/* does AM support multi-column indexes? */
@@ -310,10 +323,12 @@ typedef struct IndexAmRoutine
 	ambeginscan_function ambeginscan;
 	amrescan_function amrescan;
 	amgettuple_function amgettuple; /* can be NULL */
+	amgetbatch_function amgetbatch; /* can be NULL */
+	amunguardbatch_function amunguardbatch; /* can be NULL */
+	amkillitemsbatch_function amkillitemsbatch; /* can be NULL */
 	amgetbitmap_function amgetbitmap;	/* can be NULL */
 	amendscan_function amendscan;
-	ammarkpos_function ammarkpos;	/* can be NULL */
-	amrestrpos_function amrestrpos; /* can be NULL */
+	amposreset_function amposreset; /* can be NULL */
 
 	/* interface functions to support parallel index scans */
 	amestimateparallelscan_function amestimateparallelscan; /* can be NULL */
diff --git a/src/include/access/genam.h b/src/include/access/genam.h
index 05eec9204..615686dc2 100644
--- a/src/include/access/genam.h
+++ b/src/include/access/genam.h
@@ -96,6 +96,7 @@ typedef bool (*IndexBulkDeleteCallback) (ItemPointer itemptr, void *state);
 
 /* struct definitions appear in relscan.h */
 typedef struct IndexScanDescData *IndexScanDesc;
+typedef struct IndexScanBatchData *IndexScanBatch;
 typedef struct SysScanDescData *SysScanDesc;
 
 typedef struct ParallelIndexScanDescData *ParallelIndexScanDesc;
@@ -169,8 +170,6 @@ extern void index_rescan(IndexScanDesc scan,
 						 ScanKey keys, int nkeys,
 						 ScanKey orderbys, int norderbys);
 extern void index_endscan(IndexScanDesc scan);
-extern void index_markpos(IndexScanDesc scan);
-extern void index_restrpos(IndexScanDesc scan);
 extern Size index_parallelscan_estimate(Relation indexRelation,
 										int nkeys, int norderbys, Snapshot snapshot);
 extern void index_parallelscan_initialize(Relation heapRelation,
@@ -184,8 +183,6 @@ extern IndexScanDesc index_beginscan_parallel(Relation heaprel,
 											  int nkeys, int norderbys,
 											  ParallelIndexScanDesc pscan,
 											  uint32 flags);
-extern ItemPointer index_getnext_tid(IndexScanDesc scan,
-									 ScanDirection direction);
 extern int64 index_getbitmap(IndexScanDesc scan, TIDBitmap *bitmap);
 
 extern IndexBulkDeleteResult *index_bulk_delete(IndexVacuumInfo *info,
diff --git a/src/include/access/heapam.h b/src/include/access/heapam.h
index 4fea51761..5364ce27b 100644
--- a/src/include/access/heapam.h
+++ b/src/include/access/heapam.h
@@ -128,6 +128,7 @@ typedef struct IndexScanHeapData
 
 	/* For visibility map checks (index-only scans and on-access pruning) */
 	Buffer		xs_vmbuffer;	/* visibility map buffer */
+	int			xs_vm_items;	/* # items to resolve visibility info for */
 
 	bool		xs_readonly;	/* scan is read-only? */
 
@@ -438,8 +439,12 @@ extern TransactionId heap_index_delete_tuples(Relation rel,
 extern bool heapam_fetch_tid(Relation rel, ItemPointer tid, Snapshot snapshot,
 							 TupleTableSlot *slot, bool *all_dead);
 extern void heapam_index_scan_begin(IndexScanDesc scan, uint32 flags);
-extern void heapam_index_scan_reset(IndexScanDesc scan);
+extern void heapam_index_scan_batch_init(IndexScanDesc scan,
+										 IndexScanBatch batch);
+extern void heapam_index_scan_rescan(IndexScanDesc scan);
 extern void heapam_index_scan_end(IndexScanDesc scan);
+extern void heapam_index_scan_markpos(IndexScanDesc scan);
+extern void heapam_index_scan_restrpos(IndexScanDesc scan);
 extern bool heap_hot_search_buffer(ItemPointer tid, Relation relation,
 								   Buffer buffer, Snapshot snapshot, HeapTuple heapTuple,
 								   bool *all_dead, bool first_call);
